#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for VB Socket Library components
# C/C++ Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
# Produced By: Doug Gaer
# File Creation Date: 09/20/1999
# Date Last Modified: 07/17/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# The makefile contains all the build dependency rules for the
# additional CPP library. 
# --------------------------------------------------------------- 

# Define the $(VBSDIR) macro in the main makefile for this application
# My directory path for VB Socket CPP libraries.
# VBSDIR = $(VBS_LIBS_PATH)

# Define the $(PATHSEP) macro in the main makefile for this application
# Macro for path separator
# PATHSEP=/

# Define a path to the VBS library include files
VBSINCLUDE_PATH = $(VBSDIR)$(PATHSEP)include

# Build dependency rules
# ===============================================================
DEVCACHE_DEP =  $(VBSINCLUDE_PATH)$(PATHSEP)devcache.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)devtypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)membuf.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)memblock.h

DFILEB_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)dfileb.h

LOGFILE_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)logfile.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)ostrbase.h 

MEMBLOCK_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)memblock.h

MEMBUF_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)membuf.h

OSTRBASE_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ostrbase.h 

SCOMSERV_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbscomm.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)scomserv.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbuint32.h

SYSTIME_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)systime.h

USTRING_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h

VBCONFIG_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbconfig.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vblistb.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h

VBDATAGM_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbsocket.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbdatagm.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbheader.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBINT32_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbint32.h 

VBLISTB_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vblistb.h

VBSCOMM_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbscomm.h

VBSHTML_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbshtml.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)membuf.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vblist.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vblistb.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)dfileb.h

VBSHTTP_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vblistb.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbqueue.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstack.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbshttp.h

VBSHTTPC_DEP =  $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vblistb.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbqueue.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstack.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbsocket.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)devcache.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)memblock.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)devtypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)membuf.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbs_b64.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbshttp.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbshttpc.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbsurl.h

VBSOCKET_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbsocket.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstypes.h

VBSTREAM_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbsocket.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstream.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbheader.h \
	\$(VBSINCLUDE_PATH)$(PATHSEP)vbdtypes.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbd_ver.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbint32.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbuint32.h

VBSURL_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbsurl.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h

VBS_B64_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)ustring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbstring.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)vbs_b64.h

VBUINT32_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbuint32.h

WSERROR_DEP = $(VBSINCLUDE_PATH)$(PATHSEP)vbsocket.h \
	$(VBSINCLUDE_PATH)$(PATHSEP)wserror.h
# ---------------------------------------------------------------
#####################
#### End of File ####
#####################
