#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for VB Socket library components
# C/C++ Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
# Produced By: Doug Gaer
# File Creation Date: 09/20/1999
# Date Last Modified: 07/17/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# The makefile contains all the build rules needed to compile 
# additional CPP library components.
# --------------------------------------------------------------- 

# Define the $(VBSDIR) macro in the main makefile for this application
# My directory path for VB Socket CPP libraries.
# VBSDIR = $(VBS_LIBS_PATH)

# Define the $(PATHSEP) macro in the main makefile for this application
# Macro for path separator
# PATHSEP=/

# Define the $(OBJ_EXT) macro in the main makefile for this application
# Object file dot extension
# OBJ_EXT=.obj

# Define a path to the VBS library source code files
VBSSRC_PATH = $(VBSDIR)$(PATHSEP)src

# Rules to compile library components 
# ===============================================================
devcache$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)devcache.cpp $(DEVCACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)devcache.cpp

dfileb$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)dfileb.cpp $(DFILEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)dfileb.cpp

logfile$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)logfile.cpp $(LOGFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)logfile.cpp

memblock$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)memblock.cpp $(MEMBLOCK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)memblock.cpp

membuf$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)membuf.cpp $(MEMBUF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)membuf.cpp

ostrbase$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)ostrbase.cpp $(OSTRBASE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)ostrbase.cpp

scomserv$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)scomserv.cpp $(SCOMSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)scomserv.cpp

systime$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)systime.cpp $(SYSTIME_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)systime.cpp

ustring$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)ustring.cpp

vbconfig$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbconfig.cpp $(VBCONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbconfig.cpp

vbdatagm$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbdatagm.cpp $(VBDATAGM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbdatagm.cpp

vbint32$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbint32.cpp $(VBINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbint32.cpp

vblistb$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vblistb.cpp $(VBLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vblistb.cpp

vbscomm$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbscomm.cpp $(VBSCOMM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbscomm.cpp

vbshtml$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbshtml.cpp $(VBSHTML_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbshtml.cpp

vbshttp$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbshttp.cpp $(VBSHTTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbshttp.cpp

vbshttpc$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbshttpc.cpp $(VBSHTTPC_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbshttpc.cpp

vbsocket$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbsocket.cpp

vbstream$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbstream.cpp $(VBSTREAM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbstream.cpp

vbsurl$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbsurl.cpp $(VBSURL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbsurl.cpp

vbs_b64$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbs_b64.cpp $(VBS_B64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbs_b64.cpp

vbuint32$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)vbuint32.cpp $(VBUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)vbuint32.cpp

wserror$(OBJ_EXT):	$(VBSSRC_PATH)$(PATHSEP)wserror.cpp $(WSERROR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(VBSSRC_PATH)$(PATHSEP)wserror.cpp
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
