# Include file used for all UNIX makefiles

# Setup additional paths for includes and source code

# Build dependency rules
# ===============================================================
VBINT32_DEP = ../../include/vbint32.h 

VBUINT32_DEP = ../../include/vbuint32.h

VBSTREAM_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbstream.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h

VBDATAGM_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbdatagm.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h

VBSOCKET_DEP = ../../include/vbsocket.h ../../include/vbstypes.h

VBSCOMM_DEP = ../../include/vbscomm.h

SCOMSERV_DEP = ../../include/vbscomm.h ../../include/scomserv.h \
	../../include/vbheader.h ../../include/vbdtypes.h \
	../../include/vbd_ver.h ../../include/vbint32.h \
	../../include/vbuint32.h

DEVCACHE_DEP =  ../../include/devcache.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/memblock.h

MEMBUF_DEP = ../../include/membuf.h

MEMBLOCK_DEP = ../../include/memblock.h

VBSFILE_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbstream.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h \
	../../include/vbscomm.h ../../include/scomserv.h \
	../../include/vbdatagm.h ../../include/devcache.h \
	../../include/devtypes.h ../../include/membuf.h \
	../../include/memblock.h 

PROJECT_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbstream.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h \
	../../include/vbscomm.h ../../include/scomserv.h \
	../../include/vbdatagm.h ../../include/devcache.h \
	../../include/devtypes.h ../../include/membuf.h \
	../../include/memblock.h 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

vbint32.o:	../../src/vbint32.cpp $(VBINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbint32.cpp

vbuint32.o:	../../src/vbuint32.cpp $(VBUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbuint32.cpp

vbscomm.o:	../../src/vbscomm.cpp $(VBSCOMM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbscomm.cpp

scomserv.o:	../../src/scomserv.cpp $(SCOMSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/scomserv.cpp

vbsocket.o:	../../src/vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsocket.cpp

vbstream.o:	../../src/vbstream.cpp $(VBSTREAM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbstream.cpp

vbdatagm.o:	../../src/vbdatagm.cpp $(VBDATAGM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbdatagm.cpp

devcache.o:	../../src/devcache.cpp $(DEVCACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/devcache.cpp

membuf.o:	../../src/membuf.cpp $(MEMBUF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/membuf.cpp

memblock.o:	../../src/memblock.cpp $(MEMBLOCK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/memblock.cpp

vbsfile.o:	vbsfile.cpp $(VBSFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbsfile.cpp

$(PROJECT).o:	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

# Make the executable
OBJECTS = vbsocket.o  vbscomm.o scomserv.o vbint32.o vbuint32.o \
	vbstream.o vbdatagm.o devcache.o membuf.o memblock.o \
	vbsfile.o $(PROJECT).o
# ===============================================================
