# Include file used for all WIN32 makefiles

# Setup additional paths for includes and source code

# Build dependency rules
# ===============================================================
THELPERS_DEP = thrtypes.h thelpers.h

THRAPIW_DEP = thrtypes.h thrapiw.h vthreadt.h vbthread.h \
	thrpool.h vbmutex.h vbcond.h thelpers.h

THRPOOL_DEP = thrtypes.h thrpool.h vthreadt.h

VBCOND_DEP = thrtypes.h vbcond.h thelpers.h vbmutex.h

VBMUTEX_DEP = thrtypes.h vbmutex.h thelpers.h

VBSEMA_DEP = thrtypes.h vbsema.h thelpers.h

VBTHREAD_DEP = thrtypes.h  vbthread.h vthreadt.h thrapiw.h \
	thrpool.h

VTHREADT_DEP = thrtypes.h vthreadt.h vbthread.h thrpool.h \
	vbcond.h vbmutex.h thelpers.h

VBSOCKET_DEP = ../../include/vbsocket.h ../../include/vbstypes.h

HTTPSERV_DEP = httpserv.h thrtypes.h thelpers.h vbthread.h vthreadt.h \
	thrpool.h vbmutex.h vbcond.h vbsema.h ../../include/vbsocket.h \
	../../include/vbstypes.h

PROJECT_DEP = httpserv.h thrtypes.h thelpers.h vbthread.h vthreadt.h \
	thrpool.h vbmutex.h vbcond.h vbsema.h ../../include/vbsocket.h \
	../../include/vbstypes.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

thrapiw.obj:	thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) thrapiw.cpp

thelpers.obj:	thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) thelpers.cpp

thrpool.obj:	thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) thrpool.cpp

vbthread.obj:	vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbthread.cpp

vthreadt.obj:	vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vthreadt.cpp

vbmutex.obj:	vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbmutex.cpp

vbcond.obj:	vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbcond.cpp

vbsema.obj:	vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbsema.cpp

httpserv.obj:	httpserv.cpp $(HTTPSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) httpserv.cpp

vbsocket.obj:	../../src/vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsocket.cpp

$(PROJECT).obj:	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

# Make the executable
OBJECTS = vbthread.obj vbmutex.obj thrpool.obj vthreadt.obj vbcond.obj \
	vbsema.obj thrapiw.obj thelpers.obj httpserv.obj vbsocket.obj \
	$(PROJECT).obj
# ===============================================================
