// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: unixinfo.cpp
// C++ Compiler Used: MSVC40, HP CPP 10.24, egcs-2.90.29 
// Produced By: Doug Gaer   
// File Creation Date: 09/20/1999 
// Date Last Modified: 12/24/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This is a simple program used to obtain host information.
*/
// ----------------------------------------------------------- // 
#include <sys/utsname.h>
#include <iostream.h>

int main()
{
  struct utsname snames;
  // utsname members include:
  // sysname  - Name of the implementation of the operating system.  
  // nodename - Name of this node on the network.  
  // release  - Current release level of this implementation.  
  // version  - Current version level of this release.  
  // machine  - Name of the hardware type the system is running on.  

  int rv = uname(&snames);
  
  if(rv == -1) {
    cerr << endl;
    cerr << "Host infomation is unavailable!" << endl;
    cerr << endl;
  }
  cout << endl;
  cout << "Host name -------- ";
  if(snames.nodename[0] != 0) {
    cout << snames.nodename << endl;
  }
  else {
    cout << "Unavailable" << endl;
  }

  cout << "Machine type ----- ";
  if(snames.machine[0] != 0) {
    cout << snames.machine << endl;
  }
  else {
    cout << "Unavailable" << endl;
  }

  cout << "Operating system - ";
  if(snames.sysname[0] != 0) {
    cout << snames.sysname << endl;
  }
  else {
    cout << "Unavailable" << endl;
  }
  
  cout << "Current release -- ";
  if(snames.release[0] != 0) {
    cout << snames.release << endl;
  }
  else {
    cout << "Unavailable" << endl;
  }

  cout << "Current version -- ";
  if(snames.version[0] != 0) {
    cout << snames.version << endl;
  }
  else {
    cout << "Unavailable" << endl;
  }
  cout << endl;

  return 0;
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
