// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: part.cpp 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer 
// File Creation Date: 09/18/1997  
// Date Last Modified: 06/21/2000
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.
*/
// ----------------------------------------------------------- // 
#include "part.h"

#include <iostream.h>

PartData::PartData()
{
  id = (ID)0;
  price = (Price)0;
  for(unsigned i = 0; i < PART_NAME_LEN; i++) name[i] = 0;
}

FAU Part::WriteObject()
{
  FAU addr = Alloc(sizeof(PartData));
  if(!addr) return 0;
  
  Write(p, sizeof(PartData));

  // Write a 32-bit CRC checksum for the object
  WriteObjectChecksum(addr);
			     
  return addr;
}

void Part::ReadObject(FAU Address)
{
  // Optimize seeks during intervening reads
  SeekTo(Address);
  Read((char *)this->p, sizeof(PartData));
  
  // Test the objects checksum
  int rv = ReadObjectChecksum(Address);
  if(!rv)
#ifdef CPP_EXCEPTIONS
    throw CChecksumError();
#else
  Error->SignalException(EHandler::ChecksumError, EHandler::DISPLAY);
#endif
}

FAU Part::FindObject()
{
  int rv; // Return value

  // If not using index file or entry not found, search the data file
  PartData part;
  FAU oa;           // Object Address
  vbBlockHeader vb; // Variable Block Header
  
  FAU vbdfileEOF = GetEOF();
  FAU addr = 0;
  addr = FindFirstVB(addr); // Search the entire file

  if(addr == (FAU)0) return 0; // No variable blocks found in file

  part.id = p->id;
  part.price = p->price;
  strcpy(part.name, p->name);

  while(1) { 
    if(addr >= vbdfileEOF) break;
    Read(&vb, sizeof(vbBlockHeader), addr);
    if(vb.CkWord == vbCheckWord) {
      if((__SBYTE__)vb.Status == vbNormalBlock) {
	oa = addr + VBHeaderSize();
	ReadObject(oa);
	if(strcmp(p->name, part.name) == 0) {
	  return oa; // Found unique data member
	}
      }
      addr = addr + vb.Length; // Goto the next variable block
    }
    else {
      addr = VBSearch(addr); 
      if(!addr) break;
    }
  }

  // Reset the objects data
  p->id = part.id;
  p->price = part.price;
  strcpy(p->name, part.name);
  
  return 0; // Could not find 
}

FAU Part::ChangeObject(const PartData &new_part_info)
{
  FAU addr = FindObject();
  if(!addr) return 0; // Object does not exist
  Write(&new_part_info, sizeof(new_part_info), addr);

  // Write a 32-bit CRC checksum for the object
  WriteObjectChecksum(addr);

  strcpy(p->name, new_part_info.name);
  p->id = new_part_info.id;
  p->price = new_part_info.price;
  return addr;
}

FAU Part::DeleteObject()
{
  FAU addr = FindObject();
  if(!addr) return 0; // Object does not exist
  Delete(addr);
  return addr;
}

FAU Part::RemoveObject()
{
  FAU addr = FindObject();
  if(!addr) return 0; // Object does not exist
  Remove(addr);
  return addr;
}
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
