# Include file used for all UNIX makefiles

# Setup additional paths for includes and source code

# Build dependency rules
# ===============================================================
VBINT32_DEP = ../../include/vbint32.h 

VBUINT32_DEP = ../../include/vbuint32.h

VBSTREAM_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbstream.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h

VBSOCKET_DEP = ../../include/vbsocket.h ../../include/vbstypes.h

EHANDLER_DEP = ehandler.h

VBCRC32_DEP = vbcrc32.h vbcrctab.h

VBDREF_DEP = vbdref.h

VBDBASE_DEP = ../../include/vbint32.h ../../include/vbdtypes.h \
	../../include/vbuint32.h ../../include/vbd_ver.h \
	ehandler.h vbdbase.h vbdref.h vbcrc32.h 

VBFP64_DEP = ../../include/vbdtypes.h vbfp64.h

PART_DEP = part.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h \
	../../include/vbdtypes.h ehandler.h vbdbase.h \
	vbdref.h vbcrc32.h vbfp64.h

PROJECT_DEP = ../../include/vbsocket.h ../../include/vbstypes.h \
	../../include/vbstream.h ../../include/vbheader.h \
	../../include/vbdtypes.h ../../include/vbd_ver.h \
	../../include/vbint32.h ../../include/vbuint32.h \
	 ../../include/vbdtypes.h ehandler.h vbdbase.h \
	vbdref.h vbcrc32.h vbfp64.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

vbstream.o:	../../src/vbstream.cpp $(VBSTREAM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbstream.cpp

vbint32.o:	../../src/vbint32.cpp $(VBINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbint32.cpp

vbuint32.o:	../../src/vbuint32.cpp $(VBUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbuint32.cpp

vbsocket.o:	../../src/vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsocket.cpp

ehandler.o:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(EHANDLER_PATH)ehandler.cpp


vbdref.o:	$(VBDREF_PATH)vbdref.cpp $(VBDREF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBDREF_PATH)vbdref.cpp

vbdbase.o:    $(VBDBASE_PATH)vbdbase.cpp $(VBDBASE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBDBASE_PATH)vbdbase.cpp


vbfp64.o:	$(VBDTYPES_PATH)vbfp64.cpp $(VBFP64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBDTYPES_PATH)vbfp64.cpp

vbcrc32.o:	$(VBCRC32_PATH)vbcrc32.cpp $(VBCRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBCRC32_PATH)vbcrc32.cpp


part.o:	$(PART_PATH)part.cpp $(PART_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PART_PATH)part.cpp

$(PROJECT).o:	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

# Make the executable
OBJECTS = vbstream.o vbint32.o vbuint32.o vbsocket.o \
	ehandler.o vbfp64.o vbcrc32.o vbdbase.o vbdref.o \
	part.o $(PROJECT).o
# ===============================================================
