// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: crc32.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer    
// File Creation Date: 08/17/1998 
// Date Last Modified: 06/21/2000
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The CRC32 functions (Cyclic Redundancy Check) are used to
calculate a sophisticated checksum based on the algebra of
polynomials. The Cyclic Redundancy Check, is a way to detect
bit errors that occur during data storage or transmission.
The CRC-32 algorithm operates on a block of data as a single
large numerical value. The algorithm divides this large value
by the CRC-32 polynomial or generator polynomial, leaving the
remainder 32-bit, which is the checksum. 

Changes:
================================================================
05/31/2000: Moved the CRC32 code from the "crc32.h" and "crc32.cpp"
files to the "vbcrc32.h" and "vbcrc32.cpp" files to to elminate any
previously reported name conflicts.
Changed by: Advanced Open SQL Project

06/04/2000: Added the __USE_CRC32_TABLE_FUNCTIONS__ directive
to conditionally compile without the table functions.
Changed By: Advanced Open SQL Project
*/
// ----------------------------------------------------------- //   
#ifndef __VB_CRC32_HPP__
#define __VB_CRC32_HPP__

#include <fstream.h>

unsigned long calcCRC32(char *buf, unsigned len);
unsigned long calcCRC32(const char *buf, unsigned len);
unsigned long calcCRC32(unsigned char c, unsigned long CRC);
unsigned long calcCRC32(fstream &infile);

#ifdef __USE_CRC32_TABLE_FUNCTIONS__
#include <iostream.h>
int makeCRC32(ostream &stream);
#endif

#endif  // __VB_CRC32_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
