// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vbdbase.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer    
// File Creation Date: 02/04/1997 
// Date Last Modified: 06/21/2000
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The VBD file manager class is responsible for handling all
low-level file operations through the use of VBDFile objects
or by inheriting the VBDFile class. Low-level file operations
refer to functions such as: Create(), Open(), Read(), Write(),
Alloc(), Delete(), and Close(). These functions contain all the
routines needed to create and maintain VBD files in accordance
with the VBD File Format. VBDFile objects are reference counted
and must be created dynamically due to the way reference
counting is implemented. 

Changes:
================================================================
01/15/1998 - The template implementation in refcount.h caused a
linker error when compling under HPUX 10.20 (using HPUX CPP 1024)
in some wxWindows applications. A non-template version of the
RefCount class was added to correct the problem.
Changed by: Doug Gaer

01/15/1998 - Added the __USE_VBDREFCOUNT__ macro to enable use of
the non-template version of the Refcount class. NOTE: 06/05/2000
This directive is no longer used in version 1034 rev B and higher.
The VBD file manager now has its own implementation of the RefCount
and CountedObject classes.
Changed by: Doug Gaer

01/20/1998 - Combined the debug version with this version.
Changed by: Doug Gaer

01/20/1998 - Added BlindOpen() debug function.
Changed by: Doug Gaer

01/20/1998 - Added VBSearch() debug function.
Changed by: Doug Gaer

01/20/1998 - VBDSignature data member changed from private to
public access for compatibility with VB_DEBUG program.
Changed by: Doug Gaer

01/20/1998 - VBDVersion data member changed from private to
public assess for compatibility with VB_DEBUG program.
Changed by: Doug Gaer

02/06/1998 - The ReadVBHdr() function was changed to throw a
CSyncError execption instead of a CFileCorrupt exception for
file synchronization errors.
Changed by: Doug Gaer

03/11/1998 - Modified the Open() function to check the true
end of file and compare it to the VBD file header's end of
file. If the true end of file is greater then VBD file header's
EndOfFile value, the EndOfFile value will be changed to match the
true end of file.
Changed by: Doug Gaer

03/12/1998 -  Changed ReadHdr() function to pubilc access
so that applications can force the VBD file header to reread.
Changed by: Doug Gaer

03/13/1998 - Modified InitHdr() function to write the VBD file
header and flush the disk buffers to maintain file integrity
during multiple file access when a new file has been created.
Changed by: Doug Gaer

03/13/1998 - Modified the Write() function to allow applications 
to flush disk buffers after each write operation to ensure the
file data stays in sync during multiple file access. This approach
was used as opposed to un-buffered read and writes to maintain code
portability between all platforms.  
Changed by: Doug Gaer

03/13/1998 - Modified the Alloc() function to write the VBD file
header to disk after each allocation to ensure that the VBD file
header stays in sync during multiple file access.
Changed by: Doug Gaer

03/13/1998 - Modified the Delete() function to write the VBD file
header to disk after each deletion to ensure that the VBD file
header stays in sync during multiple file access.
Changed by: Doug Gaer

03/13/1998 - Added the TestVBDHeader() function to ensure that
the in memory copy of the VBD file header and the disk copy
stay in sync during multiple file access.
Added by: Doug Gaer

03/13/1998 - Modified the FindFirstVB() function to read the
VBD file from the disk before each search to ensure that the
VBD file header stays in sync during multiple file access.
Changed by: Doug Gaer

03/13/1998 - Modified the VBDeleted() function to read the
VBD file from the disk before each search to ensure that the
VBD file header stays in sync during multiple file access.
Changed by: Doug Gaer

03/13/1998 - Added non-const versions of GetSignature(),
GetVersion(), FileHeaderSize(), VBHeaderSize(), VBDFileName
and GetFileStatus().
Added by: Doug Gaer

03/13/1998 - Removed the const versions of the StaticArea(),
GetFreeSpace(), GetVBDFreeSpace(), GetEOF(), GetHeapStart()
and GetHighestVB() functions.
Changed by: Doug Gaer

03/13/1998 - Modified the StaticArea(), GetFreeSpace(),
GetVBDFreeSpace(), GetEOF(), GetHeapStart() and GetHighestVB()
functions to compare the in memory copy and disk copy of the
VBD file header. If they differ the VBD file header will be
reread from the disk. 
Changed by: Doug Gaer

03/16/1998 - Modified the VBTotal() function to perform its own
independent read operation. Will throw CAccessViolation exception
if an end of file error occurs during multiple file access over
an NFS mount.
Changed by: Doug Gaer

03/16/1998 - Modified the FindFirstVB() function to perform its 
own independent read operation. Will throw CAccessViolation
exception if an end of file error occurs during multiple file
access over an NFS mount.
Changed by: Doug Gaer

03/17/1998: Modified the Read() function to throw CAccessViolation
exception if an end of file error occurs during multiple file
access over an NFS mount.
Changed by: Doug Gaer

07/22/1998: In version 1025 the Open function no longer checks 
the revision letter when opening a file. Also, the last character 
of the VBDSignature member has been changed from a space to a
null byte.
Changed by: Doug Gaer

07/22/1998: Version number changed to 1025, Revsion 0, to reflect
all modifcations made from 01/15/1998 to 07/22/1998. 
Changed by: Doug Gaer

09/03/1998: Added the FSListCorrupt constant to tell the Reclaim(),
UnDelete(), and VBDeleted() functions that the free space list is
corrupt.
Added by: Doug Gaer

09/04/1998: Added two versions of the Reclaim() function, one using
the best-fit method and the other using the first-fit method. Define
the __RECLAIM_BEST_FIT__ macro to use the best-fit routine or the
__RECLAIM_FIRST_FIT__ macro to use the first-fit routine.
Added by: Doug Gaer

09/04/1998: Modifed the Reclaim() and VBDeleted() functions, allowing
them to write the FSListCorrupt constant to the file header and abort
the operation.
Changed by: Doug Gaer

09/08/1998: Changed the UnDelete() function to mange changes to the
free space list independently of the Reclaim() function.
Changed by: Doug Gaer

09/08/1998: By default the file manager will use the first-fit method
to reclaim deleted or removed blocks. The __RECLAIM_BEST_FIT__ macro
must be defined to use the best-fit method.
Changed by: Doug Gaer

09/08/1998: The Remove() function no longer allocates memory for the
length of the entire block. A single byte value, equal to zero, is
written to the file byte by byte for the length of the block.
Changed by: Doug Gaer

09/09/1998: Modified the VBDeleted() function to pass back the
total number of deleted and removed blocks in the __UWORD__ *d,
__UWORD__ *r variables.
Changed by: Doug Gaer

09/11/1998: Added the __DOS_INCLUDES__ macro for compilers that
require the use of DOS path separators in include files.
Added by: Doug Gaer

09/21/1998: Added the CalcChecksum() function. This function will
return a 32-bit CRC checksum for specified number of bytes at a
given file address.
Added by: Doug Gaer

09/24/1998: Added the GetRevLetter() function. This function will
return a single character representing the VBD file's revision
letter.
Added by: Doug Gaer

09/24/1998: Modified the InitHdr() and Open() functions to record
the VBD file's revision letter in the rev_letter variable.
Changed by: Doug Gaer

09/24/1998: Modified the Alloc() function to allocate an additional
4 bytes with each block to allow an application to store a 32-bit
checksum with each block. This changes the VBD revision letter from
zero to rev 'A'.
Changed by: Doug Gaer

09/24/1998: Modified the Write() function to perform a CRC check
with each write operation by default. The CRC check will compare
of the CRC of the buffer to the CRC of the actual bytes written to
disk. If the CRC test fails, the Write() function will throw a
CChecksumError exception.
Changed by: Doug Gaer

09/25/1998: Added the WriteObjectChecksum() function to write
a 32-bit checksum for an object in the pre-allocated space at
the end of the block. This function will return zero for any
file below revision letter 'A'.
Added by: Doug Gaer

09/25/1998: Added the ReadObjectChecksum() function to read
the 32-bit checksum of an object from the pre-allocated space
at the end of the block. This function will always return true
for any file below revision letter 'A'.
Added by: Doug Gaer

09/25/1998: Added the ReOpen() function to reassign the file
pointer to another file.
Added by: Doug Gaer

09/28/1998: Modified the Remove() function to allocate
memory for the length of the object by default. If memory
allocation fails or is disabled a single byte value, equal
to zero, is written to the file byte by byte for the length
of the object. 
Changed by: Doug Gaer

09/30/1998: Added the Rewind() function to reposition the file
pointer to the beginning of a file.
Added by: Doug Gaer

09/30/1998: Added the GetPosition() function to get the current
file position using fpos_t type.
Added by: Doug Gaer

09/30/1998: Added the SetPosition() function to reset the current
file position using fpos_t type.
Added by: Doug Gaer

09/30/1998: Added the SeekTo() function to perform an optimized
seek operation by moving the file position indicator based on the
current stream position.
Added by: Doug Gaer

10/01/1998: Modifed the Alloc() function to reposition the file
pointer to the file address where the next write operation
should take place after allocating space for an object.
Changed by: Doug Gaer

02/10/1999: An AccessViolation exception in the Read() function
is now considered fatal and will cause the program to terminate.
Changed by: Doug Gaer

04/21/1999: Added Watcom 10 patch 1031 #1. This patch provides
type casting from an int type to a vbINT32, vbUINT32, INT16,
UINT16 or FLOAT64 type as required by the Watcom compiler.
Added by: Heiko Weber

09/01/1999: Removed all instances of the VBDFile::GetFreeSpace()
function due to numerous conflicts with various compilers and
APIs. The VBDFile::GetVBDFreeSpace() function has been implemented
as a replacement.
Changed by: Doug Gaer

10/08/1999: Added the VBDFile::FindPrevObject() function used to
Search backwards through the VBD file until a valid VB is found.
Added by: Milos Jevtic

12/13/1999:
Modified the VBDFile::Close() function to set the file pointer
to zero in order to clear the file number of the last file
opened.
Changed by: Trevor Croll

05/31/2000: The VBD file version and revision number is now
set in the newly added "vbd_ver.h" file.
Changed/Added by: Advanced Open SQL Project

05/31/2000: Added the vbFileLockHeader to allow applications
to lock the entire file during a multi-thread/multi-machine
read or write operation.
Added by: Advanced Open SQL Project

05/31/2000: Added the vbRecordLockHeader to all application
to lock a specific block during a multi-thread/multi-machine
read or write operation.
Added by: Advanced Open SQL Project

06/05/2000: Changed the name of the VBD file header data
structure from FileHeader to vbFileHeader to elminate all
previously reported name conflicts.
Changed by: Advanced Open SQL Project

06/05/2000: Changed the name of the VBD block header data
structure from VBHeader to vbBlockHeader to elminate all
previously reported name conflicts.
Changed by: Advanced Open SQL Project

06/05/2000: Moved all the VBDFile manager code to the "vbdbase.h"
and "vbdbase.cpp" files. The "vbdfile.h" and "vbdfile.cpp" files
are now used for backward compatibility reasons only. This change
was neccesary to facilitate the name changes in release 1034 and
higher.
Changed by: Advanced Open SQL Project

06/05/2000: Prefaced all type definitions and constants with
the letters "vb" to avoid any future name conflicts. All the
previously used type definitions and constants were added to 
the "vbdfile.h" to maintain backward compatibiltiy.
Changed by: Advanced Open SQL Project

06/05/2000: The VBD file manager will only use the non-template
version of the RefCount class. This change was implemented to
simplify the VBD core code bundle. The __USE_VBDREFCOUNT__
directive is no longed needed.
Changed by: Advanced Open SQL Project

06/05/2000: The VBDFile::rev_letter member is now initialized 
in the VBDFile constructor and by the VBDFile::Create() function
instead of the VBDFile::InitHdr() function so that all the revision
switch statements will work correctly.
Changed by: Advanced Open SQL Project

06/05/2000: Added the lock operation and access enumerations plus
a full complement of file lock and record lock functions that operate
on the persistent lock headers. NOTE: In revision B the VBD file 
manager operates independently of the file/record lock headers. The
application is responsible for monitoring, locking, and unlocking all
persistent locks.
Added by: Advanced Open SQL Project
  
06/08/2000: Modified the VBDFile::Create() and the VBDFile::InitHdr()
functions to accept a specific revision letter when creating a new
VBD file. The VBDFile::SetRevisionLetter() function was added to
to allow specific VBD revision letters to be used statically when the
file is created or dynamically if needed.
Changed/Added by: Advanced Open SQL Project

06/08/2000: Added the VBDFile::FindPrevVB() navigation function and
modified the VBDFile::FindPrevObject() function to find the previous
block using the FindPrevVB function.
Added/Changed by: Advanced Open SQL Project 

06/10/2000: Changed VBD revision letter from 'B' to 'C'. Revision
'C' uses the second byte of the vbBlockHeader "Status" member for 
block control commands. The VBDFile::Alloc(), Delete(), Reclaim(),
Remove(), and UnDelete() functions were modified to account for
the second byte of the vbBlockHeader "Status" member.
Changed by: Doug Gaer

06/10/2000: All the VBD file and block headers, constants, and
type definitions were moved to the "vbheader.h" file to allow
other library functions and applciation to use the VBD headers
independently of the VBD file manager.
Changed/Added by: Doug Gaer   

06/16/2000: Added the __DISABLE_REFERENCE_COUNTING__ and the
__ENABLE_REFERENCE_COUNTING__ to disable reference counting.
These directives were added primarly for debugging purposes.
Added by: Doug Gaer

06/16/2000: Modified the VBDFile::Close() function to conditionally
check the reference count before closing the file.
Change by: Doug Gaer
*/
// ----------------------------------------------------------- //  
#ifndef __VB_DATABASE_HPP__
#define __VB_DATABASE_HPP__

// Enable reference counting by default
#ifndef __DISABLE_REFERENCE_COUNTING__
#define __ENABLE_REFERENCE_COUNTING__
#endif

#include <stdio.h>
#include "vbheader.h"
#include "vbcrc32.h"
#include "ehandler.h" // ehandler classed will be moved to vberror.h

#ifdef __ENABLE_REFERENCE_COUNTING__
#if defined (__USE_VBDREFCOUNT__) || defined (__NOT_USING_TEMPLATE_CLASS__)
#include "vbdref.h"
#else
#include "refcount.h"
#endif
#endif

#ifdef __ENABLE_REFERENCE_COUNTING__
class VBDFile : public CountedObject
#else
class VBDFile
#endif
{
public: // Enumerations
  enum IO_Operation { // Last I/O operation performed
    READ,  // The last operation performed was a file read
    WRITE, // The last operation performed was a file write
    SEEK,  // The last operation performed was a file seek
    REWIND // The last operation performed was a file rewind
  };
  
  enum AccessMode { // File access modes
    READWRITE, // Open file with read/write access
    READONLY   // Open file with read and write access
  };
  
  enum LockOperation { // Type of block record locks
    READLOCK,     // Value used to set the block's read lock 
    WRITELOCK,    // Value used to set the block's write lock
    READWRITELOCK // Value used to set the block's read and write lock   
  };
  
  enum LockAccessMode { // Lock access modes
    EXCLUSIVELOCK = 0xff, // Lock is exclusivly owned by one thread 
    SHAREDLOCK    = 0     // Lock is accessible to all threads
  };
  
public:
  VBDFile();
  virtual ~VBDFile();

private: // Disallow copying and assignment
  VBDFile(const VBDFile &ob) { }
  void operator=(const VBDFile &ob) { }
  
public: // Debug VBD File manager: revisions 01/20/1997
  int BlindOpen(const char *FName, 
			AccessMode Mode = VBDFile::READONLY);
  FAU VBSearch(FAU Offset = 0);     // Finds first valid Variable Block

public:
  int Create(const char *FName, FAU StaticSize = 0,
	     __SBYTE__ RevisionLetter = vbDatabaseRevisionLetter);
  int Open(const char *FName, AccessMode Mode = VBDFile::READWRITE);
  int ReOpen(const char *FName, AccessMode Mode = VBDFile::READWRITE);
  void Close(int flush = 1, int check_ref_count = 1);
  void Flush();
  FAU Alloc(__UWORD__ Bytes);
  FAU ReAlloc(FAU object_address, __UWORD__ Bytes); 
  int Delete(FAU object_address); 
  int Remove(FAU object_address, int mem_alloc = 1);
  int UnDelete(FAU object_address);
  void Read(void *buf, __UWORD__ Bytes, FAU file_adress = vbCurrAddress);
  void Write(const void *buf, __UWORD__ Bytes, 
	     FAU file_address = vbCurrAddress,
             int flush = 1, int bit_test = 1);
  void Seek(FAU Offset, int SeekMode = SEEK_SET);
  FAU SeekTo(FAU file_address);
  void Rewind();
  void SetPosition(const fpos_t fpos);
  fpos_t GetPosition();
  int IsOpen() const { return (Status & 0x02); }
  int ReadOnly() const { return (Status & 0x04) == 0; }
  int ReadyForWriting() const { return (Status & 0x07) == 0x07; }
  void ClearErr() { Error->ClearException(); Status |= 0x01; }
  int IsOK() const { return (Status & 0x03) == 0x03; }
  __UWORD__ ObjectLength(FAU object_address = vbCurrAddress);
  __UWORD__ VBLength(FAU object_address = vbCurrAddress);
  vbStreamPos FilePosition();

  // 32-bit CRC checksum routines
  __ULWORD__ CalcChecksum(__UWORD__ Bytes, FAU file_address, 
			  int mem_alloc = 1);
  vbUINT32 WriteObjectChecksum(FAU object_address);
  int ReadObjectChecksum(FAU object_address, __ULWORD__ *object_crc = 0,
			 __ULWORD__ *calc_crc = 0);

  // Static file statistics
  const char *GetSignature() const;
  char *GetSignature();
  char GetRevLetter() { return rev_letter; }
  const char GetRevLetter() const { return rev_letter; }
  vbINT32 GetVersion() const { return Header.Version; }
  vbINT32 GetVersion() { return Header.Version; }
  const char *VBDFileName() const { return (const char *)FileName; }
  char *VBDFileName() { return FileName; }
  __SBYTE__ GetFileStatus() const { return Status; }
  __SBYTE__ GetFileStatus() { return Status; }
  __LWORD__ StaticArea();

  // 05/31/2000 These functions were modified to include the size
  // of the file/block header plus the size of the file/record
  // lock header. Applications should always use these functions
  // to calculate the header sizes when computing file offsets to  
  // ensure compatibilty this release and with future releases of 
  // the VBD file manager.
  size_t FileHeaderSize() const;
  size_t FileHeaderSize(); 
  size_t VBHeaderSize() const;
  size_t VBHeaderSize();

  // 06/08/2000 Added to allow specific VBD revision letters to be
  // used statically when the file is created or dynamically.
  void SetRevisionLetter(__SBYTE__ RevisionLetter);
    
  // Dynamic file statistics
  FAU GetVBDFreeSpace(); // This version replaces GetFreeSpace() 
  FAU GetEOF();
  FAU GetHeapStart();
  FAU GetHighestVB();

  // Return total number of removed and deleted VBs
  vbINT32 VBDeleted(__UWORD__ *d = 0, __UWORD__ *r = 0);
  
  int TestVBDHeader();  // Keeps VBD file header's dynamic data in sync
  __UWORD__ VBTotal();  // Return total number of Variable Blocks

  // Navigation methods
  FAU FindFirstVB(FAU Offset = 0); // Finds first valid Variable Block
  FAU FindPrevVB(FAU Offset);      // Finds the previous block 
  FAU FindNextVB(FAU Offset = 0);  // Finds next after first 
  FAU FindFirstObject(FAU Offset = 0); // Finds first object address
  FAU FindPrevObject(FAU Offset);      // Finds the previous object 
  FAU FindNextObject(FAU Offset = 0);  // Finds next object after first 
  
public: // General purpose file utilities
  static int Exists(const char *FName);
  static __LWORD__ FileSize(const char *FName);

protected:
  FAU Reclaim(__UWORD__ Bytes); 
  void InitHdr();
  void WriteHdr();
  void ReadVBHdr(vbBlockHeader &hdr, FAU block_address = vbCurrAddress);
  void WriteVBHdr(const vbBlockHeader &hdr, FAU block_address = vbCurrAddress);

public: // 03/12/1998: Changed to public access
  void ReadHdr();

public: // File lock functions (revision B and higher)
  void InitLockHdr(vbFileLockHeader &hdr);
  int WriteLockHdr(vbFileLockHeader &hdr);
  int ReadLockHdr(vbFileLockHeader &hdr);
  void LockFile(LockAccessMode mode = VBDFile::SHAREDLOCK);
  void UnlockFile();
  void ResetFileLock();
  int TestFileLock();
  int TryLockFile();
  int IsFileLockExclusive();

public: // Record lock functions (revision B and higher)
  void InitRecordLockHdr(vbRecordLockHeader &hdr);
  void LockRecord(FAU block_address = vbCurrAddress, 
		  LockOperation type = VBDFile::WRITELOCK,
		  LockAccessMode mode = VBDFile::SHAREDLOCK);
  void UnlockRecord(FAU block_address = vbCurrAddress,
		    LockOperation type = VBDFile::WRITELOCK);
  int ReadRecordLock(vbRecordLockHeader &hdr,
		     FAU block_address = vbCurrAddress);
  int WriteRecordLock(const vbRecordLockHeader &hdr,
		      FAU block_address = vbCurrAddress);
  void ResetRecordLock(FAU block_address = vbCurrAddress);
  int TestRecordLock(FAU block_address = vbCurrAddress,
		     LockOperation type = VBDFile::WRITELOCK);
  int TryRecordLock(FAU block_address = vbCurrAddress,
		    LockOperation type = VBDFile::WRITELOCK);
  int IsRecordLockExclusive(FAU block_address = vbCurrAddress,
			    LockOperation type = VBDFile::WRITELOCK);

protected:
  char FileName[vbMaxNameLength]; // Name of the file
  char rev_letter;                // Revision number
  vbFileHeader Header;            // File header as stored in memory
  FILE *fp;                       // Stream file handle
  IO_Operation LastOperation;     // Last I/O operation
  __SBYTE__ Status; // File Status bits used in VBD Files:

public: // Static data members used in place of global variables
  static __SBYTE__ VBDSignature[8]; // Signature for VBD files
  static __LWORD__ VBDVersion;      // Version number VBD files

public: // Overloaded operators
  int operator!() const { return (Status & 0x03) != 0x03; }
  operator const int () const { return (Status & 0x03) == 0x03; }
};

#ifdef __ENABLE_REFERENCE_COUNTING__
// Type definition used to defined reference counted VBD file pointers
#if defined (__USE_VBDREFCOUNT__) || defined (__NOT_USING_TEMPLATE_CLASS__)
typedef vbdRefCount VBDFilePtr;
#else
typedef RefCount<VBDFile> VBDFilePtr;
#endif
#endif

// Type definition used to maintain consistency with the vbSocket
// and vbThread class names
typedef VBDFile vbDatabase;

#endif // __VB_DATABASE_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
