# Include file used for all UNIX makefiles

# Setup additional paths for includes and source code

# Build dependency rules
# ===============================================================
VBSOCKET_DEP = ../../include/vbsocket.h ../../include/vbstypes.h

DEVCACHE_DEP =  ../../include/devcache.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/memblock.h

MEMBUF_DEP = ../../include/membuf.h

MEMBLOCK_DEP = ../../include/memblock.h

USTRING_DEP = ../../include/ustring.h

VBLISTB_DEP = ../../include/vblistb.h

VBSHTTP_DEP = ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbshttp.h

VBSHTTPC_DEP =  ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbsocket.h \
	../../include/vbstypes.h ../../include/devcache.h \
	../../include/memblock.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/vbs_b64.h \
	../../include/vbshttp.h ../../include/vbshttpc.h \
	../../include/vbsurl.h

VBSURL_DEP = ../../include/vbsurl.h ../../include/ustring.h \
	../../include/vbstring.h

VBS_B64_DEP = ../../include/ustring.h ../../include/vbstring.h \
	../../include/vbs_b64.h

DFILEB_DEP = ../../include/dfileb.h

PROJECT_DEP =  ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbsocket.h \
	../../include/vbstypes.h ../../include/devcache.h \
	../../include/memblock.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/vbs_b64.h \
	../../include/vbshttp.h ../../include/vbshttpc.h \
	../../include/vbsurl.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

vbsocket.o:	../../src/vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsocket.cpp

devcache.o:	../../src/devcache.cpp $(DEVCACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/devcache.cpp

membuf.o:	../../src/membuf.cpp $(MEMBUF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/membuf.cpp

memblock.o:	../../src/memblock.cpp $(MEMBLOCK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/memblock.cpp

ustring.o:	../../src/ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/ustring.cpp

vbs_b64.o:	../../src/vbs_b64.cpp $(VBS_B64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbs_b64.cpp

vbsurl.o:	../../src/vbsurl.cpp $(VBSURL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsurl.cpp

dfileb.o:	../../src/dfileb.cpp $(DFILEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/dfileb.cpp

vblistb.o:	../../src/vblistb.cpp $(VBLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vblistb.cpp

vbshttp.o:	../../src/vbshttp.cpp $(VBSHTTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbshttp.cpp

vbshttpc.o:	../../src/vbshttpc.cpp $(VBSHTTPC_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbshttpc.cpp

$(PROJECT).o:	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

# Make the executable
OBJECTS = vbsocket.o  devcache.o membuf.o memblock.o \
	ustring.o vblistb.o vbshttp.o vbshttpc.o vbs_b64.o \
	vbsurl.o dfileb.o $(PROJECT).o
# ===============================================================
