# Include file used for all WIN32 makefiles

# Setup additional paths for includes and source code

# Build dependency rules
# ===============================================================
VBSOCKET_DEP = ../../include/vbsocket.h ../../include/vbstypes.h

DEVCACHE_DEP =  ../../include/devcache.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/memblock.h

MEMBUF_DEP = ../../include/membuf.h

MEMBLOCK_DEP = ../../include/memblock.h

USTRING_DEP = ../../include/ustring.h

VBLISTB_DEP = ../../include/vblistb.h

VBSHTTP_DEP = ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbshttp.h

VBSHTTPC_DEP =  ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbsocket.h \
	../../include/vbstypes.h ../../include/devcache.h \
	../../include/memblock.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/vbs_b64.h \
	../../include/vbshttp.h ../../include/vbshttpc.h \
	../../include/vbsurl.h

VBSURL_DEP = ../../include/vbsurl.h ../../include/ustring.h \
	../../include/vbstring.h

VBS_B64_DEP = ../../include/ustring.h ../../include/vbstring.h \
	../../include/vbs_b64.h

DFILEB_DEP = ../../include/dfileb.h

PROJECT_DEP =  ../../include/ustring.h ../../include/vblistb.h \
	../../include/vbstring.h ../../include/vbqueue.h \
	../../include/vbstack.h ../../include/vbsocket.h \
	../../include/vbstypes.h ../../include/devcache.h \
	../../include/memblock.h ../../include/devtypes.h \
	../../include/membuf.h ../../include/vbs_b64.h \
	../../include/vbshttp.h ../../include/vbshttpc.h \
	../../include/vbsurl.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

vbsocket.obj:	../../src/vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsocket.cpp

devcache.obj:	../../src/devcache.cpp $(DEVCACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/devcache.cpp

membuf.obj:	../../src/membuf.cpp $(MEMBUF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/membuf.cpp

memblock.obj:	../../src/memblock.cpp $(MEMBLOCK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/memblock.cpp

ustring.obj:	../../src/ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/ustring.cpp

vbs_b64.obj:	../../src/vbs_b64.cpp $(VBS_B64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbs_b64.cpp

vbsurl.obj:	../../src/vbsurl.cpp $(VBSURL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbsurl.cpp

dfileb.obj:	../../src/dfileb.cpp $(DFILEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/dfileb.cpp

vblistb.obj:	../../src/vblistb.cpp $(VBLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vblistb.cpp

vbshttp.obj:	../../src/vbshttp.cpp $(VBSHTTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbshttp.cpp

vbshttpc.obj:	../../src/vbshttpc.cpp $(VBSHTTPC_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) ../../src/vbshttpc.cpp

$(PROJECT).obj:	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

# Make the executable
OBJECTS = vbsocket.obj  devcache.obj membuf.obj memblock.obj \
	ustring.obj vblistb.obj vbshttp.obj vbshttpc.obj vbs_b64.obj \
	vbsurl.obj dfileb.obj $(PROJECT).obj
# ===============================================================
