// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: logfile.h
// C++ Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 11/17/1995 
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The LogFile class is used to log program events.
*/
// ----------------------------------------------------------- //   
#ifndef __LOGFILE_HPP__
#define __LOGFILE_HPP__

#include <time.h>
#include <fstream.h>
#include "ostrbase.h"

// Class used to log program events. 
class LogFile : public OutputStreamB
{
public:
  LogFile() { is_open = 0; }
  ~LogFile() { if(is_open) Close(); }

public:
  int Open(char *fname);
  int Open(const char *fname);
  int OverWrite(char *fname);
  int OverWrite(const char *fname);
  void Close();
  void Flush();
  
public:
  void WriteSysTime();
  void GetSystemTime(char *s, int full_month_name = 0);
  
private:
  ofstream out_file;
  int is_open;
};

#endif // __LOGFILE_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
