// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: memblock.h 
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer    
// File Creation Date: 09/20/1999
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The MemoryBlock data structure is use by the device cache
classes to store data in small blocks of memory with a fixed
length. 
*/
// ----------------------------------------------------------- //   

#ifndef __MEMBLOCK_HPP__
#define __MEMBLOCK_HPP__

const unsigned MEMORY_BLOCK_SIZE = 1024;

struct MemoryBlock {
  MemoryBlock();
  ~MemoryBlock() { }

  unsigned length() { return Len; }
  unsigned GetDimLen() { return DimLen; }
  char *m_buf() { return (char *)mem_block; } 
  const char *m_buf() const { return (char *)mem_block; } 
  void Load(const void *buf, unsigned bytes);
  int resize(unsigned bytes);
  
  char mem_block[MEMORY_BLOCK_SIZE];
  unsigned Len;    // Logical length (number of byte actually used)
  unsigned DimLen; // Maximum length of the buffer
};

#endif // __MEMBLOCK_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
