// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: scomserv.h
// C++ Compiler Used: MSVC40, HP CPP 10.24, egcs-2.90.29 
// Produced By: Doug Gaer   
// File Creation Date: 09/20/1999
// Date Last Modified: 07/17/2000
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The vbSerialCommServer class is a used to establish a client
or server connection that can transmit or receive variable
blocks over a serial port.
*/
// ----------------------------------------------------------- //   
#ifndef __VBSCOMMSERVER_HPP__
#define __VBSCOMMSERVER_HPP__

#include "vbscomm.h"
#include "vbheader.h"

// Serial communications server/client
class vbSerialCommServer : public vbSerialComm
{
public:
  vbSerialCommServer() { }
  ~vbSerialCommServer() { }
  
public: // Client/Server configuration
  int InitCommServer(char *dev, int sp = 9600, char pr = 'N', int cs = 8,
		     int sb = 1,
		     int flow = vbSerialComm::scommNO_FLOW_CONTROL);

public: // Variable block functions
  void SetBlockStatus(vbBlockHeader &vb, __SBYTE__ dev_status,
		      __SBYTE__ file_status = vbRemoteDeviceBlock);
  int WriteBlock(const void *buf, int bytes);
  int WriteBlock(const void *buf, vbBlockHeader &vb);
  int WriteHeader(vbBlockHeader &vb);
  int ReadBlock(void *buf, vbBlockHeader &vb);
  int ReadHeader(vbBlockHeader &vb);
  void *RequestBlock(const void *request, vbBlockHeader &request_header, 
		     vbBlockHeader &requested_block_header);
  int AddBlock(const void *block, vbBlockHeader &block_header);
  int DeleteBlock(const void *request, vbBlockHeader &request_header);
  int ChangeBlock(const void *request, const void *block,
		  vbBlockHeader &request_header, vbBlockHeader &block_header);
  int WriteAckBlock();
  int ReadAckBlock();
  int TerminateConnection();
  int CloseConnection();
};

#endif // __VBSCOMMSERVER_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
