// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vblist.h
// Compiler Used: MSVC40, DJGPP 2.7.2.1, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer
// File Creation Date: 12/29/1996
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

A generic doubly linked list class derived from the vbDNodeBase
class and the vbDLListBase class.
*/
// ----------------------------------------------------------- //   
#ifndef __VBLIST_HPP__
#define __VBLIST_HPP__

#include "vblistb.h"

// (D)oubly Linked List (N)ode class 
template<class TYPE>
class vbDNode : public vbDNodeBase
{
public:
  vbDNode() { } // Implicitly call default constructor for Data
  vbDNode(const TYPE &X) : Data(X) { } // Call copy constructor

public:
  vbDNode<TYPE> *GetPrior() { return (vbDNode<TYPE> *)Prior; }
  const vbDNode<TYPE> *GetPrior() const { return (vbDNode<TYPE> *)Prior; }
  vbDNode<TYPE> *GetPrev() { return (vbDNode<TYPE> *)Prior; }
  const vbDNode<TYPE> *GetPrev() const { return (vbDNode<TYPE> *)Prior; }
  vbDNode<TYPE> *GetNext() { return (vbDNode<TYPE> *)Next; }
  const vbDNode<TYPE> *GetNext() const { return (vbDNode<TYPE> *)Next; }

public:
  TYPE Data;
};

// (D)oubly (L)inked (L)ist class 
template<class TYPE>
class vbDLList : public vbDLListBase
{
public:
  vbDLList() { }
  virtual ~vbDLList();
  vbDLList(const vbDLList<TYPE> &X);
  void operator=(const vbDLList<TYPE> &X);

public:
  int Copy(const vbDLList<TYPE> &List);
  int Cat(const vbDLList<TYPE> &X) { return vbDLListBase::Cat(X); }
  const vbDNode<TYPE> *Find(const TYPE &X, const vbDNode<TYPE> *ptr=0) const;
  vbDNode<TYPE> *Find(const TYPE &X, vbDNode<TYPE> *ptr=0);
  int Delete(vbDNode<TYPE> *Node, TYPE *X = 0);
  int DeleteFront(TYPE *X = 0);
  int DeleteBack(TYPE *X = 0);
  vbDNode<TYPE> *StoreNode(const TYPE &X);
  vbDNode<TYPE> *AddToFront(const TYPE &X);
  vbDNode<TYPE> *AddToBack(const TYPE &X);
  vbDNode<TYPE> *AddBefore(const TYPE &X, vbDNode<TYPE> *Node);
  vbDNode<TYPE> *AddAfter(const TYPE &X, vbDNode<TYPE> *Node);
  vbDNode<TYPE> *GetHeader() { return(vbDNode<TYPE> *) this; }
  const vbDNode<TYPE> *GetHeader() const { return(vbDNode<TYPE> *) this; }

  vbDNode<TYPE> *GetFront() {
    return(vbDNode<TYPE> *)vbDLListBase::GetFront();
  }

  vbDNode<TYPE> *GetBack() {
    return (vbDNode<TYPE> *)vbDLListBase::GetBack();
  }
  
  const vbDNode<TYPE> *GetFront() const { // Read only version
    return(vbDNode<TYPE> *)vbDLListBase::GetFront();
  }

  const vbDNode<TYPE> *GetBack() const { // Read only version
    return (vbDNode<TYPE> *)vbDLListBase::GetBack();
  }

  int IsHeader(const vbDNode<TYPE> *Node) const {
    return vbDLListBase::IsHeader(Node);
  }
  TYPE *GetFrontNode() {
    vbDNode<TYPE> *ptr = (vbDNode<TYPE> *)vbDLListBase::GetFront();
    return IsHeader(ptr) ? 0 : &(ptr->Data);
  }

  const TYPE *GetFrontNode() const {
    vbDNode<TYPE> *ptr = (vbDNode<TYPE> *)vbDLListBase::GetFront();
    return IsHeader(ptr) ? 0 : &(ptr->Data);
  }

  TYPE *GetBackNode() {
    vbDNode<TYPE> *ptr = (vbDNode<TYPE> *)vbDLListBase::GetBack();
    return IsHeader(ptr) ? 0 : &(ptr->Data);
  }

  const TYPE *GetBackNode() const {
    vbDNode<TYPE> *ptr = (vbDNode<TYPE> *)vbDLListBase::GetBack();
    return IsHeader(ptr) ? 0 : &(ptr->Data);
  }

public:
  void InsertBefore(vbDNode<TYPE> *A, vbDNode<TYPE> *B) {
    vbDLListBase::InsertBefore(A, B);
  }

  void InsertAfter(vbDNode<TYPE> *A, vbDNode<TYPE> *B) {
    vbDLListBase::InsertAfter(A, B);
  }

  void AttachToFront(vbDNode<TYPE> *Node) {
    vbDLListBase::AttachToFront(Node);
  }

  void AttachToBack(vbDNode<TYPE> *Node) {
    vbDLListBase::AttachToBack(Node);
  }

  vbDNode<TYPE> *RmvFront() {
    return(vbDNode<TYPE> *)(vbDLListBase::RmvFront());
  }

  vbDNode<TYPE> *Rmv(vbDNode<TYPE> *Node) {
    return(vbDNode<TYPE> *)(vbDLListBase::Rmv(Node));
  }

  vbDNode<TYPE> *RmvBack() {
    return(vbDNode<TYPE> *)(vbDLListBase::RmvBack());
  }

protected:
  virtual vbDNode<TYPE> *AllocNode(const TYPE &X);
  virtual vbDNodeBase *DupNode(const vbDNodeBase *Node);
  virtual void FreeNode(vbDNodeBase *Node);

public: // Overloaded operators
  int operator+=(const vbDLList<TYPE> &X) { return Cat(X); }
};

template<class TYPE>
vbDLList<TYPE>::~vbDLList()
{
  Clear();
}

template<class TYPE>
vbDLList<TYPE>::vbDLList(const vbDLList<TYPE> &X)
{
  Copy(X);
}

template<class TYPE>
void vbDLList<TYPE>::operator=(const vbDLList<TYPE> &X)
{
  Copy(X);
}

template<class TYPE>
int vbDLList<TYPE>::Copy(const vbDLList<TYPE> &List)
{
  return vbDLListBase::Copy(List);
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::AllocNode(const TYPE &X)
{
  return new vbDNode<TYPE>(X);
}

template<class TYPE>
vbDNodeBase *vbDLList<TYPE>::DupNode(const vbDNodeBase *Node)
{
  return AllocNode(((vbDNode<TYPE> *)Node)->Data);
}

template<class TYPE>
void vbDLList<TYPE>::FreeNode(vbDNodeBase *Node)
{
  delete((vbDNode<TYPE> *)Node);
}

template<class TYPE>
const vbDNode<TYPE> *vbDLList<TYPE>::
Find(const TYPE &X, const vbDNode<TYPE> *ptr) const
// Returns the first node having an element that matched X
{
  if(ptr == 0) ptr = GetFront();

  while(!IsHeader(ptr)) { // Scan until end of list
    if(ptr->Data == X) return ptr; // Match found
    ptr = ptr->GetNext();
  }
  return 0; // No match
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::Find(const TYPE &X, vbDNode<TYPE> *ptr)
// Returns the first node having an element that matched X
{
  if(ptr == 0) ptr = GetFront();

  while(!IsHeader(ptr)) { // Scan until end of list
    if(ptr->Data == X) return ptr; // Match found
    ptr = ptr->GetNext();
  }
  return 0; // No match
}

template<class TYPE>
int vbDLList<TYPE>::Delete(vbDNode<TYPE> *Node, TYPE *X)
{
  vbDNode<TYPE> *ptr = Rmv(Node);
  if(ptr) {
    if(X) *X = ptr->Data; // Copy Data into X if X != 0
    FreeNode(ptr);
    return 1; // Return 1 if successful
  }
  return 0; 
}

template<class TYPE>
int vbDLList<TYPE>::DeleteFront(TYPE *X)
{
  vbDNode<TYPE> *ptr = RmvFront();
  if(ptr) {
    if(X) *X = ptr->Data; // Copy Data into X if X != 0
    FreeNode(ptr);
    return 1; // Return 1 if successful
  }
  return 0; 
}

template<class TYPE>
int vbDLList<TYPE>::DeleteBack(TYPE *X)
{
  vbDNode<TYPE> *ptr = RmvBack();
  if(ptr) {
    if(X) *X = ptr->Data; // Copy Data into X if X != 0
    FreeNode(ptr);
    return 1; // Return 1 if successful
  }
  return 0; 
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::StoreNode(const TYPE &X)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr) AttachToBack(ptr);
  return ptr; // Return a pointer to the node added
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::AddToFront(const TYPE &X)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr) AttachToFront(ptr);
  return ptr; // Return a pointer to the node added
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::AddToBack(const TYPE &X)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr) AttachToBack(ptr);
  return ptr; // Return a pointer to the node added
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::AddBefore(const TYPE &X, vbDNode<TYPE> *Node)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr) InsertBefore(Node, ptr);
  return ptr; // Return a pointer to the node added
}

template<class TYPE>
vbDNode<TYPE> *vbDLList<TYPE>::AddAfter(const TYPE &X, vbDNode<TYPE> *Node)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr) InsertAfter(Node, ptr);
  return ptr; // Return a pointer to the node added
}

#endif  // __VBLIST_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
