// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vblistb.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer
// File Creation Date: 12/29/1996
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Base classes for doubly linked list implementations. The
vbDNodeBase class and the vbDLListBase class separates the 
nodes from the data stored in the list by storing pointer to 
the data. Classes derived from these base classes can deal 
with any type of node data.
*/
// ----------------------------------------------------------- //   
#ifndef __VBLISTB_HPP__
#define __VBLISTB_HPP__

// Doubly Linked List Node Base class 
class vbDNodeBase
{
protected:
  friend class vbDLListBase;

protected:
  void InsertAfter(vbDNodeBase *Node);
  void InsertBefore(vbDNodeBase *Node);
  vbDNodeBase *Rmv();
  void SelfRef() { Prior = this; Next = this; }

protected:
  vbDNodeBase *Prior;
  vbDNodeBase *Next;
};

// Doubly Linked List Base Class  
class vbDLListBase : public vbDNodeBase
{
protected:
  vbDLListBase() { MakeEmpty(); }
  virtual ~vbDLListBase(); 

public:
  virtual void Clear();
  int IsEmpty() const { return (const vbDNodeBase *)Next == this; }
  int IsHeader(const vbDNodeBase *Node) const { return Node == this; }
  vbDNodeBase *GetHeader() { return this; }
  const vbDNodeBase *GetHeader() const { return this; }
  vbDNodeBase *GetFront() { return Next; }
  const vbDNodeBase *GetFront() const { return Next; }
  vbDNodeBase *GetBack() { return Prior; }
  const vbDNodeBase *GetBack() const { return Prior; }
  
protected:
  virtual vbDNodeBase *DupNode(const vbDNodeBase *Node) = 0;
  virtual void FreeNode(vbDNodeBase *Node) = 0;
  virtual void MakeEmpty(); 
  void InsertBefore(vbDNodeBase *A, vbDNodeBase *B) {
    A->InsertBefore(B); }
  void InsertAfter(vbDNodeBase *A, vbDNodeBase *B) {
    A->InsertAfter(B); }
  void AttachToFront(vbDNodeBase *Node) { InsertAfter(this, Node); }
  void AttachToBack(vbDNodeBase *Node) { InsertAfter(Prior, Node); }
  vbDNodeBase *Rmv(vbDNodeBase *Node);
  vbDNodeBase *RmvFront() { return Rmv(Next); }
  vbDNodeBase *RmvBack() { return Rmv(Prior); }
  int Copy(const vbDLListBase &List);
  int Cat(const vbDLListBase &List);
};

#endif  // __VBLISTB_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
