// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vbqueue.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 01/22/1997 
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

A generic singly linked list based stack queue. This is a
first-in, first-out (FIFO) resizable data structure. Heap
space is allocated and de-allocated with every insert and
extract operation.
*/
// ----------------------------------------------------------- //   
#ifndef __VBQUEUE_HPP__
#define __VBQUEUE_HPP__

#include "vbstack.h"

template<class TYPE>
class vbQueue : public vbStack<TYPE>
{
public:
  vbQueue() { }
  vbQueue(const vbQueue<TYPE> &X): vbStack<TYPE>(X) { }
  void operator=(const vbQueue<TYPE> &X) { Copy(X); }

public:
  int Insert(const TYPE &X);
  int Extract(TYPE &X);
  void Clear();
  TYPE *Head() { return vbStack<TYPE>::Top(); }
  const TYPE *Head() const { return vbStack<TYPE>::Top(); }
};

template<class TYPE>
int vbQueue<TYPE>::Extract(TYPE &X)
{
  return Pop(X);
}

template<class TYPE>
void vbQueue<TYPE>::Clear()
{
  vbStack<TYPE>::Rewind();
}

template<class TYPE>
int vbQueue<TYPE>::Insert(const TYPE &X)
{
  vbDNode<TYPE> *ptr = AllocNode(X);
  if(ptr == 0) return 0;
  AttachToBack(ptr);
  return 1;
}

#endif // __VBQUEUE_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //

