// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vbstream.h
// C++ Compiler Used: MSVC40, HP CPP 10.24, egcs-2.90.29 
// Produced By: Doug Gaer   
// File Creation Date: 09/20/1999
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The VBStream class is used to stream data from a client to a 
server over a TCP/IP connection.
*/
// ----------------------------------------------------------- //   
#ifndef __VBSTREAM_HPP__
#define __VBSTREAM_HPP__

#include "vbsocket.h"
#include "vbheader.h"

class vbStream : public vbSocket
{
public:
  vbStream() { }
  ~vbStream() { }

public: // Client/Server configuration
  int StreamServer(int port, int max_connections = SOMAXCONN);
  int StreamClient(int port, char *host);
  int PortNumber(int &port);
  int RemotePortNumber(int &port);
  int HostName(char *hs);
  int RemoteHostName(char *hs);
  
public: // High-level variable block functions
  int WriteBlock(const void *buf, int bytes);
  int TerminateConnection();
  int CloseConnection();
  int ReadClientHeader(vbBlockHeader &vbs);
  int ReadRemoteBlock(void *buf, vbBlockHeader &vb);
  int WriteRemoteBlock(void *buf, int bytes);
  void *RequestBlock(const void *request, vbBlockHeader &request_header, 
		      vbBlockHeader &requested_block_header);
  int AddBlock(const void *block, vbBlockHeader &block_header);
  int ChangeBlock(const void *request, const void *block, 
		  vbBlockHeader &request_header, vbBlockHeader &block_header);
  int DeleteBlock(const void *request, vbBlockHeader &request_header);
  int WriteAckBlock();
  int WriteRemoteAckBlock();
  int ReadAckBlock();
  int ReadRemoteAckBlock();
  
public: // Low-level variable block functions
  void SetBlockStatus(vbBlockHeader &vb, __SBYTE__ net_status,
		      __SBYTE__ file_status = vbRemoteDeviceBlock);
  int WriteBlock(vbsSocket_t s, const void *buf, int bytes);
  int WriteBlock(vbsSocket_t s, const void *buf, vbBlockHeader &vb);
  int WriteHeader(vbsSocket_t s, vbBlockHeader &vb);
  int ReadBlock(vbsSocket_t s, void *buf, vbBlockHeader &vb);
  int ReadHeader(vbsSocket_t s, vbBlockHeader &vb);
  void *RequestBlock(vbsSocket_t s, const void *request,
		     vbBlockHeader &request_header, 
		     vbBlockHeader &requested_block_header);
  int AddBlock(vbsSocket_t s, const void *block, vbBlockHeader &block_header);
  int DeleteBlock(vbsSocket_t s, const void *request,
		  vbBlockHeader &request_header);
  int ChangeBlock(vbsSocket_t s, const void *request, 
		  const void *block, vbBlockHeader &request_header,
		  vbBlockHeader &block_header);
  int WriteAckBlock(vbsSocket_t s);
  int ReadAckBlock(vbsSocket_t s);
  int TerminateConnection(vbsSocket_t s);
  int CloseConnection(vbsSocket_t s);
};

#endif // __VBSTREAM_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
