// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Source Code File Name: logfile.cpp 
// C++ Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 11/17/1995 
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program description and details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The LogFile class is used to log program events.
*/
// ----------------------------------------------------------- //   
#include "logfile.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

int LogFile::Open(char *fname)
{
  out_file.open(fname, ios::app);
  if (!out_file) return 1; // Could not open the file
  stream = &out_file;
  is_open = 1;
  return 0;
}

int LogFile::Open(const char *fname)
{
  out_file.open(fname, ios::app);
  if (!out_file) return 1; // Could not open the file
  stream = &out_file;
  is_open = 1;
  return 0;
}

int LogFile::OverWrite(char *fname)
{
  out_file.open(fname, ios::out);
  if (!out_file) return 1; // Could not open the file
  stream = &out_file;
  is_open = 1;
  return 0;
}

int LogFile::OverWrite(const char *fname)
{
  out_file.open(fname, ios::out);
  if (!out_file) return 1; // Could not open the file
  stream = &out_file;
  is_open = 1;
  return 0;
}

void LogFile::Close()
{
  out_file.close();
  is_open = 0;
}

void LogFile::Flush()
{
  if(is_open) out_file.flush();
}

void LogFile::WriteSysTime()
{
  if(is_open) {
    char date[255]; GetSystemTime(date);
    *(stream) << ' ' << date << ' ';
  }
}

void LogFile::GetSystemTime(char *s, int full_month_name)
// Function used to create a custom time string.
{
  time_t STime;
  struct tm *TimeBuffer;
  char month[25]; char day[25]; char year[25];
  char hour[25]; char minutes[25]; char seconds[25];
  time(&STime);
  TimeBuffer = localtime(&STime);
  if(full_month_name)
    strftime(month, 25, "%B", TimeBuffer);
  else
    strftime(month, 25, "%b", TimeBuffer);
  strftime(day, 25, "%d", TimeBuffer);
  strftime(year, 25, "%Y", TimeBuffer);
  strftime(hour, 25, "%H", TimeBuffer);
  strftime(minutes, 25, "%M", TimeBuffer);
  strftime(seconds, 25, "%S", TimeBuffer);

  // Weekday Name Month Day, Year HH:MM:SS
  sprintf(s, "%s %s, %s %s:%s:%s", month, day, year, hour, minutes, seconds);
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
