// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: memblock.cpp 
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer  
// File Creation Date: 09/20/1999
// Date Last Modified: 07/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The MemoryBlock data structure is used by the device cache
classes to store data in small blocks of memory.
*/
// ----------------------------------------------------------- //   
#include "memblock.h"
#include "string.h"

MemoryBlock::MemoryBlock()
{
  Len = 0; // No bytes are being used, set logical length to zero
  DimLen = MEMORY_BLOCK_SIZE; // Total number of bytes allocated
  for(unsigned i = 0; i < MEMORY_BLOCK_SIZE; i++) mem_block[i] = 0;
}

void MemoryBlock::Load(const void *buf, unsigned bytes)
// Load data into the memory buffer.
{
  unsigned n = bytes;
  if(n > MEMORY_BLOCK_SIZE) n = MEMORY_BLOCK_SIZE; // Prevent overflow
  Len = n; // Logical length may be smaller then the fixed block size 
  memmove(mem_block, (char *)buf, n);
}

int MemoryBlock::resize(unsigned bytes)
// Resize the logical length of this block.
// Returns false if the fixed length is exceeded.
{
  if(bytes == Len) return 1;
  if(bytes < Len) Len = bytes;

  // Do not exceed maximum fixed block length
  if(bytes > Len) {
    if(bytes <= MEMORY_BLOCK_SIZE) Len = bytes;
    if(bytes > MEMORY_BLOCK_SIZE) { Len = MEMORY_BLOCK_SIZE; return 0; }
  }
  
  return 1;
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //

